=== debian/changelog ===
spring (105.0.1+dfsg-2) unstable; urgency=medium

  * Set march flag to x86-64 on amd64. (Closes: #983807)

 -- Markus Koschany <apo@debian.org>  Tue, 02 Mar 2021 01:44:16 +0100

spring (105.0.1+dfsg-1) unstable; urgency=medium

  * New upstream version 105.0.1+dfsg.
    - The squish library is no longer embedded. (Closes: #838054)
  * Declare compliance with Debian Policy 4.5.1.
  * Refresh all patches. Remove patches which were fixed upstream.
  * Remove obsolete NEWS file.
  * Set -march flag to native on all other platforms than i386.
  * Don't install AI/Skirmish/E323AI. It's gone.
  * Install CircuitAI.

 -- Markus Koschany <apo@debian.org>  Thu, 21 Jan 2021 00:32:45 +0100
